<style>
body{
  background-color: rgba(119, 12, 16, 0.9215686274509803);
}
.slider_rewarders{
  background-color: #5F1B18;
  background: linear-gradient(to right, #752822 , #69211d, #752822);
  height: 30px;
  display: flex;
  color: #F6BD80;
  font-size: 12px;
  align-items: center;
  justify-content: center;
  position: relative;
  overflow-y: hidden;
}
.slider_cubic{
  position: relative;
}
.slider_cubic_point{
  white-space: nowrap;
  position: absolute;
  white-space: nowrap;
  perspective: 100px;
  /*transform: rotateY(321deg);*/
  margin-left: 0px;
  animation: mask_slider 10s linear infinite;
}

@keyframes mask_slider{
  0% {
    transform: translate(-10px)
  }
  /*50% {transform: rotate(180) }*/
  100% {
    transform: translate(568px)
  }
}

.turn_table_ct{
  display: flex;
  justify-content: center;
  margin-top: 18px;
  position: relative;
  overflow: hidden;
}
.record_action_ct{
  display: flex;
  justify-content: center;
  margin-top: 17px;
  margin-bottom: 28px;
}
.record_action{
  color: #fff;
  background-color: #E69335;;
  font-size: 15px;
  height: 45px;
  display: flex;
  align-items: center;
  padding: 0px 35px;
  border-radius: 50px;
  text-decoration: none;
}
.game_des{
  color: rgba(216, 155, 91, 1);
  /*padding-top: 45px;*/
}
.rule_title{
  font-size: 15px;
  font-weight: 400;
  display: flex;
  align-items: center;
  justify-content: center;
}
.rule_text{
  margin-left: 6px;
  margin-right: 6px;
}
.rule_items_ct{
  padding: 19px 15px 0px 27px;
  font-size: 12px;
  line-height: 27px;
}
.share_btn{
  height: 50px;
  position: fixed;
  bottom: 0px;
  left: 0px;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  color: #fff;
  font-size: 16px;
  background-color: #D98628;
}
.table_ct{
  padding: 5px;
  background-color: #FF661F1B;
}
table{
  width: 100%;
  border-spacing: 0px;
}
table tr:last-child td{
  border-bottom: 0px;
}
table tr td{
  border-bottom: 1px solid #FF6C2824;
  border-right: 1px solid #FF6C2824;
  line-height: 30px;
  padding-left: 13px;
  width: 50%;
}
table tr td:last-child{
  border-right: 0px;
}
.slider_mask{
  background: repeating-linear-gradient(90deg, #f7f6f675 0%, #f9f9f700 20%, #fbfbf900 50%, #fbfbfa00 80%, #f5f2f252 100%);
  background: repeating-linear-gradient(90deg, #8c0f1d 0%, #f9f9f700 40%, #fbfbf900 50%, #fbfbfa00 60%, #8c0f1d 100%);
  position: absolute;
  top: 0px;
  height: 100%;
  width: 100%;
}
@-webkit-keyframes rotate {
  0% {
    -webkit-transform: rotate(0deg)
  }
  /*50% {-webkit-transform: rotate(180deg); }*/
  100% {
    -webkit-transform: rotate(360deg);
  }
}
@-ms-keyframes rotate {
  0% {
    -ms-transform: rotate(0deg);    
  }
  /*50% {-ms-transform: rotate(180deg); }*/
  100% {
    -ms-transform: rotate(360deg);
  }
}
@keyframes rotate {
  0% {
    transform: rotate(0deg)
  }
  /*50% {transform: rotate(180) }*/
  100% {
    transform: rotate(360deg)
  }
}
.roate_turn_table{
  animation: rotate 0.3s linear infinite;
}
.rotate_to_l1{
  animation: rotate 0.8s linear;
  transform: rotate(360deg);
}
.load_scatter{
  position: absolute;
  left: 0px;
  top: 0px;
  width: 100%;
  height: 100%;
}
/**/

/*cubic*/

.wrap {
  perspective: 800px;
  perspective-origin: 50% 150px;
}
.cube {
  position: relative;
  width: 300px;
  transform-style: preserve-3d;

  position: absolute;
  z-index: 1;
  top: 50px;
  left: 50%;
  margin-left: -150px;
}
.cube div {
  position: absolute;
  width: 300px;
  height: 300px;
  display: flex;
  align-items: center;
  justify-content: center;
  color: #fff;
}
.back {
  transform: translateZ(-150px) rotateY(180deg);
}
.right {
  transform: rotateY(-270deg) translateX(150px);
  transform-origin: top right;
  background-color: rgba(0, 0, 10, 0.1);
}
.left {
  transform: rotateY(270deg) translateX(-150px);
  transform-origin: center left;
}
.top {
  transform: rotateX(-90deg) translateY(-150px);
  transform-origin: top center;
}
.bottom {
  transform: rotateX(90deg) translateY(150px);
  transform-origin: bottom center;
}
.front {
  transform: translateZ(150px);
}
@keyframes spin {
  from { transform: rotateY(0); }
  to { transform: rotateY(360deg); }
}


.cube {
  animation: spin 5s infinite linear;
}
.slider_cubic_point{
  display: flex;
}
.slider_cubic_point div{
  padding: 0px 20px;
}
</style>
<template>
  <div>
    <div class="style_load_img"></div>
    <!-- <div class="wrap">
      <div class="cube">
        <div class="front">codk 抽中了600 EOSC</div>
        <div class="back">codk 抽中了600 EOSC</div>
        <div class="top">上</div>
        <div class="bottom">下</div>
        <div class="left">codk 抽中了600 EOSC</div>
        <div class="right">codk 抽中了600 EOSC</div>
      </div>
    </div> -->

    <div v-if="has_authed">

      <div class="turn_table_header">
        <div class="turn_table_header_top_nav"></div>
        <div class="turn_table_header_main"></div>
      </div>

      <!-- slider_rewarders_start -->
      <div class="slider_rewarders">
        <!-- <div class="slider_cubic"> -->
          <div class="slider_cubic_point" v-if="recent_record.data.length">
            <div v-for="item in recent_record.data">{{ item.to }} 抽中了{{ item.token_nums }} {{ item.token_type }}</div>
            <!-- <span>codk 抽中了600 EOSC</span>
            <span>codk 抽中了600 EOSC</span>
            <span>codk 抽中了600 EOSC</span>
            <span>codk 抽中了600 EOSC</span>
            <span>codk 抽中了600 EOSC</span>
            <span>codk 抽中了600 EOSC</span>
            <span>codk 抽中了600 EOSC</span>
            <span>codk 抽中了600 EOSC</span> -->
          </div>
          <div class="slider_mask"></div>
        <!-- </div> -->
      </div>
      <!-- slider_rewarders_end -->
      <!-- turn_table_ct_start -->
      <div class="turn_table_ct">
        <div class="turn_table" v-bind:class="{'roate_turn_table': on_load_reward}" v-bind:style="reward_style">
        </div>
        <div class="turn_table_core" @click="start_check">
          <div class="turn_table_core_arrow"></div>
        </div>
      </div>
      <!-- turn_table_ct_end -->
      <div class="record_action_ct">
        <router-link :to="{name: 'record'}" class="record_action" v-if="scatter_config.account.name">我的中奖纪录</router-link>
        <!-- <a href="" class="record_action">我的中奖纪录</a> -->
      </div>

      <div class="game_des">
        <div class="game_des_header"></div>
        <h2 class="rule_title">
          <div>-</div>
          <div class="rule_text">活动规则</div>
          <div>-</div>
        </h2>
        <div class="rule_items_ct">
          <ul>
            <li>
              活动期间，在麦子钱包使用EOSC账户即可进行抽奖。
            </li>
            <li>
              分享活动到微信或朋友圈即可额外获取一次抽奖机会，每人每天最多抽奖两次。                        
            </li>
            <li>
              <div>奖池设置:</div>
              <div class="table_ct">
                <table>
                  <tr>
                    <td>绝地(200000 JEDI)</td>
                    <td>猜拳(400000GTP)</td>
                  </tr>
                  <tr>
                    <td>awake(50000 EAT)</td>
                    <td>欧柚(60000 LD0X)</td>
                  </tr>
                  <tr>
                    <td>原力(50000EOSC)</td>
                    <td>Cindydaily(60000 KAN)</td>
                  </tr>
                  <tr>
                    <td>汪星喵(20000000BANK)</td>
                    <td></td>
                  </tr>
                </table>
              </div>
            </li>
            <li>
              ERC20，中奖后将在三个工作日内发放                        
            </li>
          </ul>
        </div>
      </div>
      <div class="share_btn" @click="share_action"> {{ share_text }} </div>
      <dialog_box v-if="dialog_box_config.title" v-bind:config="dialog_box_config" v-bind:on_load="dialog_box_config.on_load" v-on:confirm="add_eth_addr" v-on:close="clear_dialog_box_config"></dialog_box>
      
    </div>
  </div>
</template>
<script>
import '../../assets/css/turn_table.css'
import { wait_time, transfer_for_update_ethaddr } from './utils.js'
import dialog_box from './dialog.vue'
import axios from 'axios'
import Eos from 'eosforce'
import mathwallet from 'math-js-sdk'
import share_img from '../../assets/image/web/turn_table/turn_table_share.jpg'
const httpEndpoint = 'https://w3.eosforce.cn'
const network = {
    protocol: 'https',
    blockchain: 'eos',
    host: 'w1.eosforce.cn',
    port: 443,
    chainId: 'bd61ae3a031e8ef2f97ee3b0e62776d6d30d4833c8f7c1645c657b149151004b',
}

const check_reward = async (_form_data) => {
  let url = '/turn_table/get_reward';
  let data = await axios.post(url, _form_data);
  return data.data;
}

const update_eth_addr = async (_form_data) => {
  // /update/eth_addr
  let url = '/turn_table/update/eth_addr';
  let data = await axios.post(url, _form_data);
  return data.data;
}

const auth_cookie = async (_form_data = {}) => {
  let url = '/turn_table/auth';
  let data = await axios.post(url, _form_data);
  return data.data;
}

const update_user_times = async (_form_data = {}) => {
  // /update/user_time_times
  let url = '/turn_table/update/user_time_times';
  let data = await axios.post(url, _form_data);
  return data.data;
}

const recent_record = async () => {
  // recent_record
  let url = '/turn_table/recent_record';
  let data = await axios.post(url);
  return data.data;
}

const check_times = async (_form_data) => {
  let url = '/turn_table/check_times';
  let data = await axios.post(url, _form_data);
  return data.data;
}


// 
export default {
  data () {
    return {
      has_authed: false,

      reject_scatter: false,
      scatter_config: {
        check_config_error: false,
        error_msg: '',
        options: {},
        account: {
          name: ''
        },
        eos: null,
        permission: 'active',
        load_times: 0
      },
      on_load_reward: false,
      select_reward_token: '',
      reward_list: [
        'EOSC',
        'JEDI',
        'GTP',
        'EAT',
        'KAN&LD0X',
        'BANK',
      ],
      dialog_box_config: {
        title: '',
        on_load: false
      },
      reward_times: {
        on_load: false,
        times: 1,
        data: []
      },
      recent_record: {
        data: []
      },
      share_text: '转发好友，获得一次抽奖机会'
    }
  },

  computed: {
    reward_style () {
      let rotate = this.select_reward_token ? this.reward_list.indexOf(this.select_reward_token) * 60 : 30;
      // rotate = rotate * 60;
      return {
        'transform': `rotate(${rotate}deg)`
      }
    }
  },

  watch: {
    'scatter_config.account' () {
      this.check_times();
    }
  },
  async mounted () {
    document.body.style.cssText = 'background: rgba(119, 12, 16, 0.9215686274509803)';
    this.init_auth_cookie();
    this.check_scatter();   
    this.init_recent_record(); 
  },

  components: {
    dialog_box
  },

  methods: {
    async init_auth_cookie () {
      await auth_cookie().catch(err => {
        alert(err);
      })
      this.has_authed = true;
    },
    async check_times () {
      let res = await check_times({
        name: this.scatter_config.account.name
      });
      if(!res.data.length){
        this.reward_times.times = 1;
      }else{
        this.reward_times.times = res.data[0].times - res.data[0].used_times;
      }
    },
    async init_recent_record () {
      let result = await recent_record();
      this.recent_record.data.splice(0, 0, ...result.data);
      console.log(this.recent_record);
    },
    async check_scatter () {
      if(!window.scatter){
        console.log('check scatter');
        this.scatter_config.load_times ++;
        await wait_time(1);
        await this.check_scatter();
      }else{
        console.log('check_scatter');
        await this.init_scatter_eos();
      }
    },
    async init_scatter_eos () {
      if(this.scatter_config.eos) return this.scatter_config.eos;
      let identity = await scatter.getIdentity({accounts:[network]}).catch(err => {
          this.scatter_config.check_config_error = true;
          this.scatter_config.error_msg = err;
          throw err;
        });

        this.scatter_config.check_config_error = false;
        this.scatter_config.error_msg = '';

        const account = identity.accounts.find(function(acc){
             return acc.blockchain === 'eos';
        });
        let options = {
         authorization: account.name+'@'+account.authority,
         broadcast: true,
         sign: true
        }    
        this.scatter_config.options = options;
        this.scatter_config.account = account;
        this.scatter_config.permission = account.authority;
        this.scatter_config.eos = this.scatter_config.eos || scatter.eos(network, Eos,  options, "https");
        console.log('load scatter end');
        return this.scatter_config.eos;
    },
    async start_check () {

      // alert('【很遗憾来晚了，本期大转盘活动已结束】');

      // return ;
      
      if(!window.scatter){
        alert('请在麦子钱包打开当前链接')
        return ;
      }

      if(this.scatter_config.error_msg){
        alert(JSON.stringify(this.scatter_config.error_msg));
        this.check_scatter();
        return ;
      }

      if(this.reward_times.times <= 0){
        alert('您的抽奖次数已用完');
        return ;
      }

      if(this.on_load_reward) return ;
      this.on_load_reward = true;

      let start_time = new Date().getTime();

      let data = await check_reward({
        name: this.scatter_config.account.name
      }).catch(error => {
        alert(error);
        this.on_load_reward = false;        
        throw error;
      });

      await wait_time( 2 - (new Date().getTime() - start_time)/1000 );
      this.on_load_reward = false;
      this.check_times();
      this.clear_dialog_box_config();

      if(data.status == 0){
        this.select_reward_token = data.data.token_type;

        Object.assign(this.dialog_box_config, data.data);
        this.dialog_box_config.title = '恭喜抽中';
        this.dialog_box_config.name = this.scatter_config.account.name;
        if(data.data.token_type == 'KAN&LD0X'){
          this.dialog_box_config.is_eth_addr = true;
          this.dialog_box_config.on_load = false;
        }
      }else{
        this.select_reward_token = '';
        this.dialog_box_config.title = data.msg;
      }
    },
    async add_eth_addr (eth_addr) {
     if(this.dialog_box_config.on_load) return ;
      this.dialog_box_config.on_load = true;
      let id = this.dialog_box_config.id;


      let identity = await scatter.getIdentity({accounts:[network]});
      const account = identity.accounts.find(function(acc){
           return acc.blockchain === 'eos';
      });
      let options = {
       authorization: account.name+'@'+account.authority,
       broadcast: true,
       sign: true
      } 
      let eos_instance = scatter.eos(network, Eos,  options, "https");
      eos_instance.getInfo({});
      let eos = await eos_instance.contract('eosio');
      let tr = await eos.transfer(account.name, 'eosclucky', '0.0000 EOS','update eth addr', {
        actor: account.name,
        permission: account.authority
      }).catch(err => {
        this.dialog_box_config.on_load = false;
        throw err;
      })
      
      let res = await update_eth_addr({
        name: account.name,
        eth_addr: eth_addr,
        id,
        trx_id: tr.transaction_id
      });

      if(res.status == 0){
        this.clear_dialog_box_config();
        this.record.find(item => item.id == id).eth_addr = eth_addr;
      }else{
        this.dialog_box_config.on_load = false;
        alert(res.msg);
      }

    },
    async share_action () {
      let res = await update_user_times(
        {
          name: this.scatter_config.account.name
        }
      );
      mathwallet.postCustomMessage('shareAction',{
        type : 1,
        imageURL : 'https://explorer.eosforce.io/turn_table_share_2019_2_26.png',
        activity : {
            "type": "event",
            "app": "app",
            "event": "share",
            "name": 'eosforce',
            "data": ''
          }
      }).then(i => {
        // alert('end');
      });
      this.check_times();
      if(res.status != 0){
        this.share_text = res.msg;
      }else{
        this.share_text = '已增加一次抽奖机会';
      }
    },
    clear_dialog_box_config () {
      for(let _key in this.dialog_box_config){
        this.dialog_box_config[_key] = '';
      }
    }
},
}
</script>

